;;;-*- Mode: Lisp; Syntax: Common-Lisp; Base: 10; Package: accessors -*-
;;; -----------------------------------------------------------------------------------
;;; TITLE: 
;;; -----------------------------------------------------------------------------------
;;;
;;; DESCRIPTION: 
;;;
;;; REQUIRES: 
;;; 
;;; NOTES: 
;;;
;;; PROBLEMS: 
;;;
;;; CONTACT:  
;;;
;;; HISTORY:

;;; CREATED: 04/12/1992 by *hf* 
;;; *rr* 26.01.93
;;; *rr* 22.01.93 einige neue slots
;;;
;;; END OF HISTORY
;;; -----------------------------------------------------------------------------------

#module accessors

(import (level-0-eulisp
         (only (intern concatenate string)
           common-lisp))
 syntax (level-0-eulisp))

(defmacro defaccessors aclist
  `(progn ,@(da1 aclist)))

(defun da1 (aclist)
  (if (null aclist) ()
      (let ((el (car aclist)))
        `(,(mk!acc el)
          ,(ex!acc el)
          ,(mk?acc el)
          ,(ex?acc el)
          ,@(da1 (cdr aclist)))
        )))

(defun mk!acc (sym)
  `(defgeneric ,(intern (concatenate 'cl:string "!" (string sym)))
     (arg what)))

(defun mk?acc (sym)
  `(defgeneric ,(intern (concatenate 'cl:string "?" (string sym)))
     (arg)))

(defun ex!acc (sym) 
  `(export ,(intern (concatenate 'cl:string "!" (string sym)))))

(defun ex?acc (sym) 
  `(export ,(intern (concatenate 'cl:string "?" (string sym)))))

#|
(defaccessors
(
access-id 
actual
address     ;*wh*
alignment       ; *wh* 
all-names       ;*rr* 
allocation 
allocator                               ; <class-def>
allow-other-keys 
applications 
arg 
arg-list 
arg-num 
argument-precedence-order 
basis       ;*rr*
bit-length  ; *wh* 
body 
bottom
byte-length ; *wh* 
c-imports                               ; <module>
calls 
case-list 
class 
classes       ;*rr*
class-def-list 
; closure-place *hf*
closure-vars  
code
code-identifier ;*wh*
code-name       ;*rr*
complement
components       ;*rr*
component-in       ;*rr*
component-type 
constant-value 
constructor-for                         ; <constructor-fun>
cont 
converter                               ; <class-def>
data-type       ;*rr*
definition
discrimination-depth                    ; <generic-fun>
discriminating-fun                      ; <generic-fun>
domain                                  ; <generic-fun>, <method-def>
element-types 
else 
else-interface
expanded                                ; <literal-instance>
expanded-literal                        ; <structured-literal>
exported
first-form
first-name        ;*rr*
first-path-fixed-statements       ;*rr*
fixed-statements       ;*rr*
form 
form-list
fread-gloc        ; *hf*
free-blocks       ;*rr*
free-list        ;*rr*
free-statements       ;*rr*
fun 
fun-list 
function 
function-label 
function-type 
fwrite-gloc           ; *hf*
gc-not-needed                           ; <literal-instance>
generic-fun 
gplace                ; *hf*
glocs                 ; *hf*
id
identifier
init 
init-list 
initarg                                 ; <slot-desc>
initargs                                ; <class-def>
initform
initialization
initial-value                           ; <global-static>
initvalue                               ; <slot-desc>
integer     ;*wh*
intern-name    ;*wh* 
key-list 
lattice-type
length-of-vector    ;*wh*
label               ;*ak* , tagged-form
link 
location
max-type     ;*wh* 
method-class                            ; <generic-fun>
method-list                             ; <generic-fun>
method-lookup-fun                       ; <generic-fun>
mm-card                                 ; *wh*
mm-type                                 ; *wh*
module-id
moves ; *hf*
name 
named-const-list
next-type    ;*ak*
node-type    ;*ak*
number-of-already-used-codes 
object-type
offset					;*rr* 
operator				;*ak*
opt-list 
options 
otherwise 
package 
params
parts        ;*ak*
pass 
place   
pred
pre-names-and-pre-types       ;*wh*
produser-of-free-located-values       ;*rr*
produser-of-locked-located-values        ;*rr*
qualifier-list 
read-gloc                      ; *hf*
read-gloc-list                 ; *hf*
read-glocs
read-stats
ready       ;*rr*
rec-calls
reduce ; *hf*
representation                          ; *wh*
rest 
rclass       ;*rr*
rnumber       ;*rr*
rclass-name       ;*rr*
scope     ;*wh*
set-gvars 
set-of-registers       ;*rr*
signed            ;*wh*
size
slot     ;*wh*
slot-and-type-names    ;*wh* 
slot-types 
slots 
specializer-list 
statement-list				;*rr*
subexprs				;*ak*
subtypes 
successor-blocks
supers 
supertypes 
suppl 
sym 
sym-list
sys-glocs             ; *hf* 
table 
tagbody 
tagged-form-list 
tests ; hf
then 
top
top-type-name     ;*wh* 
toplevel-forms 
type 
type-descr 
type-descr-s 
type-identifier  ; class-def
types 
used-gvars
used-for        ;*rr*
user-of-located-values       ;*rr*
used-runtime-modules ; module
used-syntax-modules  ; module
value  
value-list 
var
var-code       ;*wh*  
var-descr 
var-list  
var-value
variant-and-type-names     ;*wh*
write-gloc      ; *hf*
write-gloc-list ; *hf*
write-glocs
write-stats))
|#

(defaccessors ; --- structure slots of LZS ---
allow-other-keys
arg
arg-list
body
case-list
class
class-def-list
constant-value
cont
converter
direct-slots
domain
else
exported
first-form
form
form-list
fun
fun-list
function
init
init-list
initarg
initfunction
key-list
location
method-class
method-list
name
named-const-list
opt-list
options
otherwise
package
params
pred
rest
setter
supers
suppl
sym
sym-list
tagbody
tagged-form-list
then
toplevel-forms
value
value-list
var
var-list
)

(defaccessors ; --- annotation slots of LZS ---
accessor
actual
allocator
applications
arg-num
c-imports
calls
class-precedence-list
closure
closure-vars
code-identifier
constructor-for
constructors
copy-fun
definition
discriminating-fun
discrimination-arguments
discrimination-depth
effective-slots
equal-pred
eval-value
expanded
expanded-literal
exports
fread-gloc
function-label
function-type
fwrite-gloc
gc-not-needed
gc-tracer
generic-fun
identifier
initargs
initial-value
initialization
initvalue
inline
interpreter
label
lattice-type
lex-env
link
match-list
method-lookup-fun
module-id
moves
offset
pass
place
predicate
protocol-type
range-and-domain
read-gloc
read-gloc-list
read-glocs
read-stats
reader
rec-calls
reduce
representation
signature
slot
slot-of
specializes
statement-status
subclasses
syntax-env
syntax-exports
sys-glocs
tests
type
type-descr
type-descr-s
type-identifier
type-list
used-runtime-modules
used-syntax-modules
var-descr
write-gloc
write-gloc-list
write-glocs
write-stats
writer
)

(defaccessors ; --- structure slots of MZS ---
;NOTE that some structure slots of the MZS have the same name as annotation
;slots of the LZS
application
basis
block
closure-call
constant-counter
context
data-type
else-block
end-blocks
error-spec
in-block
in-label
interface
killed-places
new-type-vars
num
out-block
out-blocks
out-label
rclass
ready
result
rnumber
start-block
stat
t-descr-before
then-block
tnr
type-spec
type-vars
type-vec
used-places
value-type
var-vec
)

(defaccessors ; --- annotation slots of MZS ---
divided
else-interface
else-type-descr-s
env
env-level
in-binding
kill-binding
out-binding
pathes
rebind-vars
successor-blocks
t-descr-after
t-path
then-type-descr-s
)

#module-end ;end of module accessors